<script>
export default {
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      openTab: 0,
    };
  },
  mounted() {
    this.selectTab(0);
  },
  methods: {
    selectTab(index) {
      this.openTab = index;
    },
  },
};
</script>

<template>
  <section class="badges" :class="{ light: data.variant === 'light' }">
    <SlpContainer>
      <div>
        <SlpTypography tag="h2" variant="heading2-bold" class="header">
          {{ data.header }}
        </SlpTypography>
        <div role="tablist" class="tablist">
          <button
            v-for="(tab, index) in data.tabs"
            :id="`tab-${tab.tab_id}`"
            :key="tab.tab_id"
            type="button"
            role="tab"
            :data-ga-name="`${tab.tab_name} tab`"
            data-ga-location="badge section "
            class="tab"
            :class="{ selected: openTab === index }"
            :aria-selected="openTab == index"
            :aria-controls="`${tab.tab_id}panel`"
            @click="selectTab(index)"
          >
            <SlpIcon
              class="icon"
              :name="tab.tab_icon"
              variant="marketing"
              alt=""
              aria-hidden="true"
              style="width: 24px; height: 24px"
            />
            <span>{{ tab.tab_name }}</span>
          </button>
        </div>

        <div
          v-for="(tab, index) in data.tabs"
          v-show="openTab == index"
          :id="`${tab.tab_id}panel`"
          :key="`${tab.tab_id}-content`"
          role="tabpanel"
          class="tabpanel"
          :aria-labelledby="`tab-${tab.tab_id}`"
        >
          <div class="tabpanel__content-wrapper" aria-live="polite">
            <div class="tabpanel__copy" v-html="$md.render(tab.copy)"></div>
            <SlpButton
              v-if="tab.cta"
              class="cta desktop"
              :href="tab.cta.url"
              :data-ga-name="tab.cta.data_ga_name"
              :data-ga-location="tab.cta.data_ga_location"
              variant="primary"
              >{{ tab.cta.cta_text || 'Learn more' }}
              <SlpIcon variant="product" name="chevron-lg-right"
            /></SlpButton>
          </div>
          <div v-if="tab.badge_images" class="badge-cards">
            <img
              v-for="image in tab.badge_images"
              :key="image.src"
              :src="image.src"
              :alt="image.alt"
              width="96px"
              height="122px"
              loading="lazy"
            />
          </div>
          <div v-if="tab.analysts" class="analyst-cards">
            <a
              v-for="(analyst, i) in tab.analysts"
              :key="`analyst-${i}`"
              :href="analyst.link.url"
              :data-ga-name="analyst.link.data_ga_name"
              :data-ga-location="analyst.link.data_ga_location"
              class="analyst-cards__card"
            >
              <img :src="analyst.logo" height="16px" loading="lazy" />
              <SlpTypography tag="p" variant="body3-bold">{{
                analyst.text
              }}</SlpTypography>
            </a>
          </div>
          <SlpButton
            v-if="tab.cta"
            class="cta mobile"
            :href="tab.cta.url"
            :data-ga-name="tab.cta.data_ga_name"
            :data-ga-location="tab.cta.data_ga_location"
            variant="primary"
            >Learn more <SlpIcon variant="product" name="chevron-lg-right"
          /></SlpButton>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.badges {
  background: $color-surface-700;
  color: $color-surface-50;
  padding: $spacing-96 0;
  margin-bottom: $spacing-96;

  &.light {
    color: $color-text-300;
    background: white;
    @media (max-width: $breakpoint-lg) {
      margin-bottom: 0;
    }
    .header {
      @media (min-width: $breakpoint-lg) {
        max-width: 50%;
      }
    }
    .tablist {
      margin-bottom: 0;
      gap: 0;
      @media (max-width: $breakpoint-lg) {
        flex-direction: row;
        overflow: scroll;
      }
      .tab {
        padding: $spacing-16 $spacing-32;
        min-width: 0;
        text-align: left;
        @media (max-width: $breakpoint-lg) {
          min-width: 200px;
          padding: $spacing-16;
        }
      }
      button {
        border-radius: 0;
        background: white;
        border-top: 2px solid transparent;
        &.selected {
          background: $color-surface-800;
          border-top: 2px solid #7759c2;
        }

        .icon.slp-icon {
          width: 24px !important;
          height: 24px !important;
          max-width: 24px !important;
        }
      }
    }
    .tabpanel {
      background: $color-surface-800;
      padding: $spacing-48;
      border-radius: 0px 24px 24px 24px;
      letter-spacing: -1.1px;
      @media (max-width: $breakpoint-md) {
        border-radius: 0 0 24px 24px;
      }
      .cta {
        background: $color-surface-700;
        color: $color-text-50;
        &:hover {
          background: $color-surface-50;
          color: $color-text-300;
        }
      }
    }
  }
  h2 {
    margin-bottom: $spacing-64;

    @media (max-width: $breakpoint-md) {
      margin-bottom: $spacing-24;
    }
  }

  .tablist {
    margin-bottom: $spacing-64;
    display: flex;
    gap: 16px;

    button {
      border: none;
      background: $color-surface-800;
      color: $color-text-300;
      font-weight: $font-weight-bold;
      font-size: $text-body-2;
      line-height: $line-height-body-2;
      padding: $spacing-16;
      cursor: pointer;
      border-radius: 4px;
      display: flex;
      align-items: center;
      min-width: 360px;
      min-height: 56px;
      transition: background 0.2s ease;

      &.selected,
      &:hover {
        background: $color-surface-950;
      }

      .icon {
        margin-right: $spacing-8;
        max-width: 24px;
        max-height: 24px;
      }
    }

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      margin-bottom: $spacing-24;

      button {
        min-width: 100%;
      }
    }
  }

  .tabpanel {
    display: flex;
    flex-direction: row;
    justify-content: space-between;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
    }

    &__copy {
      font-size: $text-heading-4;
      line-height: $line-height-heading-4;
      max-width: 445px;
      margin-bottom: $spacing-24;

      @media (max-width: $breakpoint-md) {
        font-size: $text-heading-4-mobile;
        line-height: $line-height-heading-4-mobile;
      }
    }

    &__content-wrapper {
      flex: 1 0 50%;
    }
  }
  .cta {
    background: $color-surface-50;
    color: $color-text-300;
    border: 1px solid transparent;

    &:hover {
      background: $color-surface-700;
      color: $color-text-50;
      border: 1px solid $color-surface-50;
    }

    .slp-icon {
      margin-left: $spacing-8;
    }

    &.desktop {
      display: inline-flex;
    }

    &.mobile {
      display: none;
    }

    @media (max-width: $breakpoint-md) {
      &.desktop {
        display: none;
      }
      &.mobile {
        display: inline-flex;
        justify-content: center;
        text-align: center;
        margin-top: $spacing-32;
      }
    }
  }

  .badge-cards {
    flex: 1 0 50%;
    position: relative;
    justify-content: flex-start;
    display: flex;
    flex-wrap: wrap;
    gap: 42px;

    @media (max-width: $breakpoint-md) {
      gap: 24px;
      justify-content: center;
    }
  }

  .analyst-cards {
    display: grid;
    grid-template-columns: 1fr 1fr;
    @media (max-width: $breakpoint-md) {
      grid-template-columns: 1fr;
      gap: 16px;
    }
    position: relative;
    flex-wrap: wrap;
    gap: 16px 24px;
    &__card {
      border-radius: 8px;
      background: $color-surface-50;
      color: #000;
      padding: $spacing-16;
      max-width: 280px;
      max-height: 140px;
      height: 100%;
      width: 100%;
    }

    img {
      margin-bottom: 4px;
    }

    @media (max-width: $breakpoint-md) {
      &__card {
        max-width: 100%;
        margin-bottom: $spacing-8;
      }
    }
  }
}
</style>
